/*
 * Copyright (C) 2013-2014 Nick Guletskii
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

GLOBALLY_SYNCHRONIZE_FUNCTION(glCreateShader, GLuint, (GLenum a1), (a1))
GLOBALLY_SYNCHRONIZE_FUNCTION(glCreateProgram, GLuint, (), ())
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glShaderSource, (GLuint shader, GLsizei count, const GLchar *const*string, const GLint *length), (shader, count, string, length))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCompileShader, (GLuint shader), (shader))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glAttachShader, (GLuint a1, GLuint a2), (a1, a2))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glLinkProgram, (GLuint a1), (a1))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetShaderiv, (GLuint shader, GLenum pname, GLint *params), (shader, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetShaderInfoLog, (GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *infoLog), (shader, bufSize, length, infoLog))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glReadBuffer, (GLenum mode), (mode))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDrawRangeElements, (GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const void *indices), (mode, start, end, count, type, indices))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexImage3D, (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const void *pixels), (target, level, internalformat, width, height, depth, border, format, type, pixels))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexSubImage3D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void *pixels), (target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCopyTexSubImage3D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height), (target, level, xoffset, yoffset, zoffset, x, y, width, height))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCompressedTexImage3D, (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const void *data), (target, level, internalformat, width, height, depth, border, imageSize, data))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCompressedTexSubImage3D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const void *data), (target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGenQueries, (GLsizei n, GLuint *ids), (n, ids))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteQueries, (GLsizei n, const GLuint *ids), (n, ids))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsQuery, GLboolean, (GLuint id), (id))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBeginQuery, (GLenum target, GLuint id), (target, id))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glEndQuery, (GLenum target), (target))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetQueryiv, (GLenum target, GLenum pname, GLint *params), (target, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetQueryObjectuiv, (GLuint id, GLenum pname, GLuint *params), (id, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION(glUnmapBuffer, GLboolean, (GLenum target), (target))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetBufferPointerv, (GLenum target, GLenum pname, void **params), (target, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDrawBuffers, (GLsizei n, const GLenum *bufs), (n, bufs))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformMatrix2x3fv, (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value), (location, count, transpose, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformMatrix3x2fv, (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value), (location, count, transpose, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformMatrix2x4fv, (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value), (location, count, transpose, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformMatrix4x2fv, (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value), (location, count, transpose, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformMatrix3x4fv, (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value), (location, count, transpose, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformMatrix4x3fv, (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value), (location, count, transpose, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBlitFramebuffer, (GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter), (srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glRenderbufferStorageMultisample, (GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height), (target, samples, internalformat, width, height))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glFramebufferTextureLayer, (GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer), (target, attachment, texture, level, layer))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glFlushMappedBufferRange, (GLenum target, GLintptr offset, GLsizeiptr length), (target, offset, length))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteVertexArrays, (GLsizei n, const GLuint *arrays), (n, arrays))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsVertexArray, GLboolean, (GLuint array), (array))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBeginTransformFeedback, (GLenum primitiveMode), (primitiveMode))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glEndTransformFeedback, (void), ())
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindBufferRange, (GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size), (target, index, buffer, offset, size))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindBufferBase, (GLenum target, GLuint index, GLuint buffer), (target, index, buffer))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTransformFeedbackVaryings, (GLuint program, GLsizei count, const GLchar *const*varyings, GLenum bufferMode), (program, count, varyings, bufferMode))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetTransformFeedbackVarying, (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name), (program, index, bufSize, length, size, type, name))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttribIPointer, (GLuint index, GLint size, GLenum type, GLsizei stride, const void *pointer), (index, size, type, stride, pointer))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetVertexAttribIiv, (GLuint index, GLenum pname, GLint *params), (index, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetVertexAttribIuiv, (GLuint index, GLenum pname, GLuint *params), (index, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttribI4i, (GLuint index, GLint x, GLint y, GLint z, GLint w), (index, x, y, z, w))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttribI4ui, (GLuint index, GLuint x, GLuint y, GLuint z, GLuint w), (index, x, y, z, w))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttribI4iv, (GLuint index, const GLint *v), (index, v))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttribI4uiv, (GLuint index, const GLuint *v), (index, v))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetUniformuiv, (GLuint program, GLint location, GLuint *params), (program, location, params))
GLOBALLY_SYNCHRONIZE_FUNCTION(glGetFragDataLocation, GLint, (GLuint program, const GLchar *name), (program, name))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform1ui, (GLint location, GLuint v0), (location, v0))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform2ui, (GLint location, GLuint v0, GLuint v1), (location, v0, v1))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform3ui, (GLint location, GLuint v0, GLuint v1, GLuint v2), (location, v0, v1, v2))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform4ui, (GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3), (location, v0, v1, v2, v3))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform1uiv, (GLint location, GLsizei count, const GLuint *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform2uiv, (GLint location, GLsizei count, const GLuint *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform3uiv, (GLint location, GLsizei count, const GLuint *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform4uiv, (GLint location, GLsizei count, const GLuint *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glClearBufferiv, (GLenum buffer, GLint drawbuffer, const GLint *value), (buffer, drawbuffer, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glClearBufferuiv, (GLenum buffer, GLint drawbuffer, const GLuint *value), (buffer, drawbuffer, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glClearBufferfv, (GLenum buffer, GLint drawbuffer, const GLfloat *value), (buffer, drawbuffer, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glClearBufferfi, (GLenum buffer, GLint drawbuffer, GLfloat depth, GLint stencil), (buffer, drawbuffer, depth, stencil))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCopyBufferSubData, (GLenum readTarget, GLenum writeTarget, GLintptr readOffset, GLintptr writeOffset, GLsizeiptr size), (readTarget, writeTarget, readOffset, writeOffset, size))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetUniformIndices, (GLuint program, GLsizei uniformCount, const GLchar *const*uniformNames, GLuint *uniformIndices), (program, uniformCount, uniformNames, uniformIndices))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetActiveUniformsiv, (GLuint program, GLsizei uniformCount, const GLuint *uniformIndices, GLenum pname, GLint *params), (program, uniformCount, uniformIndices, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION(glGetUniformBlockIndex, GLuint, (GLuint program, const GLchar *uniformBlockName), (program, uniformBlockName))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetActiveUniformBlockiv, (GLuint program, GLuint uniformBlockIndex, GLenum pname, GLint *params), (program, uniformBlockIndex, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetActiveUniformBlockName, (GLuint program, GLuint uniformBlockIndex, GLsizei bufSize, GLsizei *length, GLchar *uniformBlockName), (program, uniformBlockIndex, bufSize, length, uniformBlockName))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformBlockBinding, (GLuint program, GLuint uniformBlockIndex, GLuint uniformBlockBinding), (program, uniformBlockIndex, uniformBlockBinding))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDrawArraysInstanced, (GLenum mode, GLint first, GLsizei count, GLsizei instancecount), (mode, first, count, instancecount))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDrawElementsInstanced, (GLenum mode, GLsizei count, GLenum type, const void *indices, GLsizei instancecount), (mode, count, type, indices, instancecount))
GLOBALLY_SYNCHRONIZE_FUNCTION(glFenceSync, GLsync, (GLenum condition, GLbitfield flags), (condition, flags))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsSync, GLboolean, (GLsync sync), (sync))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteSync, (GLsync sync), (sync))
GLOBALLY_SYNCHRONIZE_FUNCTION(glClientWaitSync, GLenum, (GLsync sync, GLbitfield flags, GLuint64 timeout), (sync, flags, timeout))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glWaitSync, (GLsync sync, GLbitfield flags, GLuint64 timeout), (sync, flags, timeout))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetInteger64v, (GLenum pname, GLint64 *data), (pname, data))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetSynciv, (GLsync sync, GLenum pname, GLsizei bufSize, GLsizei *length, GLint *values), (sync, pname, bufSize, length, values))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetBufferParameteri64v, (GLenum target, GLenum pname, GLint64 *params), (target, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGenSamplers, (GLsizei count, GLuint *samplers), (count, samplers))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteSamplers, (GLsizei count, const GLuint *samplers), (count, samplers))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsSampler, GLboolean, (GLuint sampler), (sampler))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindSampler, (GLuint unit, GLuint sampler), (unit, sampler))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glSamplerParameteri, (GLuint sampler, GLenum pname, GLint param), (sampler, pname, param))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glSamplerParameteriv, (GLuint sampler, GLenum pname, const GLint *param), (sampler, pname, param))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glSamplerParameterf, (GLuint sampler, GLenum pname, GLfloat param), (sampler, pname, param))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glSamplerParameterfv, (GLuint sampler, GLenum pname, const GLfloat *param), (sampler, pname, param))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetSamplerParameteriv, (GLuint sampler, GLenum pname, GLint *params), (sampler, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetSamplerParameterfv, (GLuint sampler, GLenum pname, GLfloat *params), (sampler, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttribDivisor, (GLuint index, GLuint divisor), (index, divisor))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindTransformFeedback, (GLenum target, GLuint id), (target, id))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteTransformFeedbacks, (GLsizei n, const GLuint *ids), (n, ids))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGenTransformFeedbacks, (GLsizei n, GLuint *ids), (n, ids))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsTransformFeedback, GLboolean, (GLuint id), (id))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glPauseTransformFeedback, (void), ())
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glResumeTransformFeedback, (void), ())
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetProgramBinary, (GLuint program, GLsizei bufSize, GLsizei *length, GLenum *binaryFormat, void *binary), (program, bufSize, length, binaryFormat, binary))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glProgramBinary, (GLuint program, GLenum binaryFormat, const void *binary, GLsizei length), (program, binaryFormat, binary, length))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glProgramParameteri, (GLuint program, GLenum pname, GLint value), (program, pname, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glInvalidateFramebuffer, (GLenum target, GLsizei numAttachments, const GLenum *attachments), (target, numAttachments, attachments))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glInvalidateSubFramebuffer, (GLenum target, GLsizei numAttachments, const GLenum *attachments, GLint x, GLint y, GLsizei width, GLsizei height), (target, numAttachments, attachments, x, y, width, height))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexStorage2D, (GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height), (target, levels, internalformat, width, height))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexStorage3D, (GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth), (target, levels, internalformat, width, height, depth))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetInternalformativ, (GLenum target, GLenum internalformat, GLenum pname, GLsizei bufSize, GLint *params), (target, internalformat, pname, bufSize, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glActiveTexture, (GLenum texture), (texture))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindAttribLocation, (GLuint program, GLuint index, const GLchar *name), (program, index, name))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindFramebuffer, (GLenum target, GLuint framebuffer), (target, framebuffer))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindRenderbuffer, (GLenum target, GLuint renderbuffer), (target, renderbuffer))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindTexture, (GLenum target, GLuint texture), (target, texture))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBlendColor, (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha), (red, green, blue, alpha))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBlendEquation, (GLenum mode), (mode))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBlendEquationSeparate, (GLenum modeRGB, GLenum modeAlpha), (modeRGB, modeAlpha))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBlendFunc, (GLenum sfactor, GLenum dfactor), (sfactor, dfactor))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBlendFuncSeparate, (GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha), (sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBufferData, (GLenum target, GLsizeiptr size, const void *data, GLenum usage), (target, size, data, usage))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBufferSubData, (GLenum target, GLintptr offset, GLsizeiptr size, const void *data), (target, offset, size, data))
GLOBALLY_SYNCHRONIZE_FUNCTION(glCheckFramebufferStatus, GLenum, (GLenum target), (target))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glClear, (GLbitfield mask), (mask))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glClearColor, (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha), (red, green, blue, alpha))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glClearDepthf, (GLfloat d), (d))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glClearStencil, (GLint s), (s))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glColorMask, (GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha), (red, green, blue, alpha))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCompressedTexImage2D, (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const void *data), (target, level, internalformat, width, height, border, imageSize, data))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCompressedTexSubImage2D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const void *data), (target, level, xoffset, yoffset, width, height, format, imageSize, data))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCopyTexImage2D, (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border), (target, level, internalformat, x, y, width, height, border))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCopyTexSubImage2D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height), (target, level, xoffset, yoffset, x, y, width, height))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glCullFace, (GLenum mode), (mode))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteBuffers, (GLsizei n, const GLuint *buffers), (n, buffers))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteFramebuffers, (GLsizei n, const GLuint *framebuffers), (n, framebuffers))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteProgram, (GLuint program), (program))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteRenderbuffers, (GLsizei n, const GLuint *renderbuffers), (n, renderbuffers))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteShader, (GLuint shader), (shader))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDeleteTextures, (GLsizei n, const GLuint *textures), (n, textures))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDepthFunc, (GLenum func), (func))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDepthMask, (GLboolean flag), (flag))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDepthRangef, (GLfloat n, GLfloat f), (n, f))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDetachShader, (GLuint program, GLuint shader), (program, shader))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDisable, (GLenum cap), (cap))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDisableVertexAttribArray, (GLuint index), (index))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDrawArrays, (GLenum mode, GLint first, GLsizei count), (mode, first, count))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDrawElements, (GLenum mode, GLsizei count, GLenum type, const void *indices), (mode, count, type, indices))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glEnable, (GLenum cap), (cap))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glEnableVertexAttribArray, (GLuint index), (index))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glFinish, (void), ())
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glFlush, (void), ())
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glFramebufferRenderbuffer, (GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer), (target, attachment, renderbuffertarget, renderbuffer))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glFramebufferTexture2D, (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level), (target, attachment, textarget, texture, level))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glFrontFace, (GLenum mode), (mode))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGenerateMipmap, (GLenum target), (target))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGenFramebuffers, (GLsizei n, GLuint *framebuffers), (n, framebuffers))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGenRenderbuffers, (GLsizei n, GLuint *renderbuffers), (n, renderbuffers))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetActiveAttrib, (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name), (program, index, bufSize, length, size, type, name))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetActiveUniform, (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name), (program, index, bufSize, length, size, type, name))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetAttachedShaders, (GLuint program, GLsizei maxCount, GLsizei *count, GLuint *shaders), (program, maxCount, count, shaders))
GLOBALLY_SYNCHRONIZE_FUNCTION(glGetAttribLocation, GLint, (GLuint program, const GLchar *name), (program, name))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetBooleanv, (GLenum pname, GLboolean *data), (pname, data))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetBufferParameteriv, (GLenum target, GLenum pname, GLint *params), (target, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION(glGetError, GLenum, (void), ())
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetFloatv, (GLenum pname, GLfloat *data), (pname, data))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetFramebufferAttachmentParameteriv, (GLenum target, GLenum attachment, GLenum pname, GLint *params), (target, attachment, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetIntegerv, (GLenum pname, GLint *data), (pname, data))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetProgramiv, (GLuint program, GLenum pname, GLint *params), (program, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetProgramInfoLog, (GLuint program, GLsizei bufSize, GLsizei *length, GLchar *infoLog), (program, bufSize, length, infoLog))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetShaderPrecisionFormat, (GLenum shadertype, GLenum precisiontype, GLint *range, GLint *precision), (shadertype, precisiontype, range, precision))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetShaderSource, (GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *source), (shader, bufSize, length, source))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetTexParameterfv, (GLenum target, GLenum pname, GLfloat *params), (target, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetTexParameteriv, (GLenum target, GLenum pname, GLint *params), (target, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetUniformfv, (GLuint program, GLint location, GLfloat *params), (program, location, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetUniformiv, (GLuint program, GLint location, GLint *params), (program, location, params))
GLOBALLY_SYNCHRONIZE_FUNCTION(glGetUniformLocation, GLint, (GLuint program, const GLchar *name), (program, name))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetVertexAttribfv, (GLuint index, GLenum pname, GLfloat *params), (index, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetVertexAttribiv, (GLuint index, GLenum pname, GLint *params), (index, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glGetVertexAttribPointerv, (GLuint index, GLenum pname, void **pointer), (index, pname, pointer))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glHint, (GLenum target, GLenum mode), (target, mode))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsBuffer, GLboolean, (GLuint buffer), (buffer))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsEnabled, GLboolean, (GLenum cap), (cap))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsFramebuffer, GLboolean, (GLuint framebuffer), (framebuffer))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsProgram, GLboolean, (GLuint program), (program))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsRenderbuffer, GLboolean, (GLuint renderbuffer), (renderbuffer))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsShader, GLboolean, (GLuint shader), (shader))
GLOBALLY_SYNCHRONIZE_FUNCTION(glIsTexture, GLboolean, (GLuint texture), (texture))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glLineWidth, (GLfloat width), (width))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glPixelStorei, (GLenum pname, GLint param), (pname, param))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glPolygonOffset, (GLfloat factor, GLfloat units), (factor, units))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glReadPixels, (GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, void *pixels), (x, y, width, height, format, type, pixels))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glReleaseShaderCompiler, (void), ())
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glRenderbufferStorage, (GLenum target, GLenum internalformat, GLsizei width, GLsizei height), (target, internalformat, width, height))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glSampleCoverage, (GLfloat value, GLboolean invert), (value, invert))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glScissor, (GLint x, GLint y, GLsizei width, GLsizei height), (x, y, width, height))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glShaderBinary, (GLsizei count, const GLuint *shaders, GLenum binaryformat, const void *binary, GLsizei length), (count, shaders, binaryformat, binary, length))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glStencilFunc, (GLenum func, GLint ref, GLuint mask), (func, ref, mask))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glStencilFuncSeparate, (GLenum face, GLenum func, GLint ref, GLuint mask), (face, func, ref, mask))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glStencilMask, (GLuint mask), (mask))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glStencilMaskSeparate, (GLenum face, GLuint mask), (face, mask))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glStencilOp, (GLenum fail, GLenum zfail, GLenum zpass), (fail, zfail, zpass))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glStencilOpSeparate, (GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass), (face, sfail, dpfail, dppass))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexImage2D, (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const void *pixels), (target, level, internalformat, width, height, border, format, type, pixels))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexParameterf, (GLenum target, GLenum pname, GLfloat param), (target, pname, param))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexParameterfv, (GLenum target, GLenum pname, const GLfloat *params), (target, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexParameteri, (GLenum target, GLenum pname, GLint param), (target, pname, param))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexParameteriv, (GLenum target, GLenum pname, const GLint *params), (target, pname, params))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glTexSubImage2D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const void *pixels), (target, level, xoffset, yoffset, width, height, format, type, pixels))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform1f, (GLint location, GLfloat v0), (location, v0))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform1fv, (GLint location, GLsizei count, const GLfloat *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform1i, (GLint location, GLint v0), (location, v0))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform1iv, (GLint location, GLsizei count, const GLint *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform2f, (GLint location, GLfloat v0, GLfloat v1), (location, v0, v1))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform2fv, (GLint location, GLsizei count, const GLfloat *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform2i, (GLint location, GLint v0, GLint v1), (location, v0, v1))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform2iv, (GLint location, GLsizei count, const GLint *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform3f, (GLint location, GLfloat v0, GLfloat v1, GLfloat v2), (location, v0, v1, v2))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform3fv, (GLint location, GLsizei count, const GLfloat *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform3i, (GLint location, GLint v0, GLint v1, GLint v2), (location, v0, v1, v2))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform3iv, (GLint location, GLsizei count, const GLint *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform4f, (GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3), (location, v0, v1, v2, v3))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform4fv, (GLint location, GLsizei count, const GLfloat *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform4i, (GLint location, GLint v0, GLint v1, GLint v2, GLint v3), (location, v0, v1, v2, v3))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniform4iv, (GLint location, GLsizei count, const GLint *value), (location, count, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformMatrix2fv, (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value), (location, count, transpose, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformMatrix3fv, (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value), (location, count, transpose, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUniformMatrix4fv, (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value), (location, count, transpose, value))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glValidateProgram, (GLuint program), (program))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttrib1f, (GLuint index, GLfloat x), (index, x))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttrib1fv, (GLuint index, const GLfloat *v), (index, v))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttrib2f, (GLuint index, GLfloat x, GLfloat y), (index, x, y))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttrib2fv, (GLuint index, const GLfloat *v), (index, v))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttrib3f, (GLuint index, GLfloat x, GLfloat y, GLfloat z), (index, x, y, z))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttrib3fv, (GLuint index, const GLfloat *v), (index, v))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttrib4f, (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w), (index, x, y, z, w))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttrib4fv, (GLuint index, const GLfloat *v), (index, v))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glVertexAttribPointer, (GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const void *pointer), (index, size, type, normalized, stride, pointer))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glViewport, (GLint x, GLint y, GLsizei width, GLsizei height), (x, y, width, height))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindFragDataLocation, (GLuint program, GLuint colorNumber, const char * name), (program, colorNumber, name))
GLOBALLY_SYNCHRONIZE_FUNCTION(glGetDebugMessageLog, GLuint, (GLuint count, GLsizei bufSize, GLenum *sources, GLenum *types, GLuint *ids, GLenum *severities, GLsizei *lengths, GLchar *messageLog), (count, bufSize, sources, types, ids, severities, lengths, messageLog))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glDebugMessageControl, (GLenum source, GLenum type, GLenum severity, GLsizei count, const GLuint *ids, GLboolean enabled), (source, type, severity, count, ids, enabled))
SYNCHRONIZE_FUNCTION_VOID_RET(glGenVertexArrays, (GLsizei n, GLuint *arrays), (n, arrays))
SYNCHRONIZE_FUNCTION_VOID_RET(glGenBuffers, (GLsizei n, GLuint *arrays), (n, arrays))
SYNCHRONIZE_FUNCTION_VOID_RET(glGenTextures, (GLsizei n, GLuint *arrays), (n, arrays))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindBuffer,(GLuint target, GLuint buffer), (target,buffer))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glBindVertexArray, (GLuint array), (array))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glUseProgram,(GLuint program), (program))
GLOBALLY_SYNCHRONIZE_FUNCTION_VOID_RET(glPolygonMode, (GLenum face, GLenum mode), (face, mode));
