/*
 * Copyright (C) 2013-2014 Nick Guletskii
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef UTILS_HPP_
#define UTILS_HPP_
#include<string>
#include<utility>
#include<boost/format.hpp>
#include<X11/Xlib.h>
namespace glxosd {

struct KeyCombo {
	KeySym keySym;
	KeyCode keyCode;
	unsigned long int mask;
};

std::string getEnvironment(const std::string & var);

std::pair<int, int> getDPI();

uint64_t getMonotonicTimeNanoseconds();

KeyCombo stringToKeyCombo(std::string, Display*);

bool keyComboMatches(KeyCombo combo, XKeyEvent* event);

boost::format glxosdFormat(const std::string & str);
}
#endif
